/* graphcrypt.h - global header file for the graphcrypt application
 *
 * Copyright (C) 2001  Jochen Voss.
 *
 * $Id: graphcrypt.h,v 1.2 2001/09/17 22:57:48 voss Rel $ */

#ifndef FILE_GRAPHCRYPT_H_SEEN
#define FILE_GRAPHCRYPT_H_SEEN


/* The resolution of the noise in dots per inch.
 * The image resolution is half this value.  */
#define  DPI  100

typedef  unsigned char  uchar;

struct image {
  uchar *data;
  int  w, h, pitch;
};


/* from "main.c" */
extern  long int  key_id;


/* from "image.c" */
extern  void  handle_image (const char *infile, const char *outfile);


/* from "shade.c" */
extern  void  prepare (struct image *im);
extern  void  shade (struct image *dest, struct image *src);
extern  void  diffuse (struct image *dest, struct image *src);
extern  void  diffuse_rnd (struct image *dest, struct image *src);
extern  void  gibbs_diffuse (struct image *dest, struct image *src,
			     double beta);
extern  void  gibbs_diffuse_rnd (struct image *dest, struct image *src,
				 double beta);

/* from "encrypt.c" */
extern  void  generate_key (int key);
extern  void  postscript_print_key (const char *filename);
extern  void  postscript_print_encrypted_image (const char *filename,
						const char *title,
						struct image *im);

/* from "postscript.c" */
extern  int  page_width (void);
extern  int  page_height (void);
extern  void  postscript_print_image (const char *filename, const char *title,
				      struct image *im,
				      int xoffset, int yoffset);

#endif /* FILE_GRAPHCRYPT_H_SEEN */
